diff -uNr slrn.orig/src/art.c slrn/src/art.c
--- slrn.orig/src/art.c	Tue Mar 12 13:48:44 2002
+++ slrn/src/art.c	Wed Jun 26 10:05:36 2002
@@ -144,6 +144,8 @@
 
 int Slrn_Del_Article_Upon_Read = 1;
 
+int Slrn_Usenet_Digest_Forward = 0;
+
 char *Slrn_Current_Group_Name;
 Slrn_Header_Type *Slrn_First_Header;
 Slrn_Header_Type *Slrn_Current_Header;
@@ -2756,6 +2758,7 @@
 static void forward_article (void) /*{{{*/
 {
    char *subject;
+   char *newsgroups;
    Slrn_Article_Line_Type *l;
    FILE *fp;
    char file[256];
@@ -2801,6 +2804,10 @@
      }
 
    subject = slrn_extract_header ("Subject: ", 9);
+   if (subject == NULL) subject = "";
+
+   newsgroups = slrn_extract_header ("Newsgroups: ",12);
+   if (newsgroups == NULL) newsgroups = "";
    
    fprintf (fp, "To: %s\n", to); n = 4;
    
@@ -2811,7 +2818,14 @@
 	fprintf (fp, "From: %s\n", from); n++;
      }
    
-   fprintf (fp, "Subject: Fwd: %s\n", subject == NULL ? "" : subject);
+   if (Slrn_Usenet_Digest_Forward)
+     {
+	fprintf (fp, "Subject: [%s] %s\n", newsgroups, subject);
+     } 
+   else 
+     {
+	fprintf (fp, "Subject: Fwd: %s\n", subject);
+     }
    
    if (0 != *Slrn_User_Info.replyto)
      {
diff -uNr slrn.orig/src/art.h slrn/src/art.h
--- slrn.orig/src/art.h	Mon Mar 11 16:39:37 2002
+++ slrn/src/art.h	Wed Jun 26 10:05:36 2002
@@ -60,6 +60,7 @@
 extern int Slrn_Quotes_Hidden_Mode;
 extern int Slrn_Verbatim_Marks_Hidden;
 extern int Slrn_Warn_Followup_To;
+extern int Slrn_Usenet_Digest_Forward;
 
 extern char *Slrn_X_Browser;
 
diff -uNr slrn.orig/src/startup.c slrn/src/startup.c
--- slrn.orig/src/startup.c	Mon Mar 11 16:19:27 2002
+++ slrn/src/startup.c	Wed Jun 26 10:07:19 2002
@@ -547,6 +547,7 @@
      {"write_newsrc_flags", &Slrn_Write_Newsrc_Flags},
      {"query_read_group_cutoff", &Slrn_Query_Group_Cutoff},
      {"max_queued_groups", &Slrn_Max_Queued_Groups},
+     {"usenet_digest_forward",&Slrn_Usenet_Digest_Forward},
      {"use_header_numbers", &Slrn_Use_Header_Numbers},
      {"use_localtime", &Slrn_Use_Localtime},
 #if SLRN_HAS_SPOILERS
